/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.util.io;

import java.io.IOException;


/**
 * Created by The eXo Platform SARL
 * Author : Peter Nedonosko
 *          peter.nedonosko@exoplatform.com.ua
 * 20.10.2006
 * @author <a href="mailto:peter.nedonosko@exoplatform.com.ua">Peter Nedonosko</a>
 * @version $Id: LazySharedFileInputStream.java 12843 2007-02-16 09:11:18Z peterit $
 */
public class LazySharedFileInputStream extends LazyFileInputStream {

  public LazySharedFileInputStream(SharedFile file) {
    super(file);
    file.lockUsed(this);
  }

  @Override
  public LazySharedFileInputStream clone() {
    return new LazySharedFileInputStream(getSourceFile());
  }

  @Override
  protected SharedFile getSourceFile() {
    return (SharedFile) file;
  }

  @Override
  public void close() throws IOException {
    getSourceFile().unlockUsed(this);
    super.close();
  }
  
}