/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import javax.jcr.AccessDeniedException;
import javax.jcr.Node;
import javax.jcr.RepositoryException;

import org.exoplatform.services.webdav.FakeLockTable;
import org.exoplatform.services.webdav.resource.AbstractNodeResource;
import org.exoplatform.services.webdav.resource.DavResource;
import org.exoplatform.services.webdav.resource.DeltaVResource;
import org.exoplatform.services.webdav.resource.NodeResource;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: UnLockCommand.java 12004 2007-01-17 12:03:57Z geaz $
 */

public class UnLockCommand extends WebDavCommand {
  
  protected boolean process() throws RepositoryException {
    String resourcePath = davRequest().getSrcWorkspace() + davRequest().getSrcPath();      
    FakeLockTable lockTable = davContext().getLockTable();      
    String presentLockToken = lockTable.getLockToken(resourcePath);

    if (presentLockToken != null) {
      lockTable.unLockResource(resourcePath);
      davResponse().answerNoContent();
      return true;
    }
    
    DavResource resource = getResourceFactory().getSrcResource(false);
    
    if (!(resource instanceof NodeResource) &&
        !(resource instanceof DeltaVResource)) {
      throw new AccessDeniedException();
    }

    Node node = ((AbstractNodeResource)resource).getNode();    
    node.unlock();
    node.getSession().save();
    
    davResponse().answerNoContent();    
    return true;
  }
  
}
