/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands.deltav;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

import org.exoplatform.services.webdav.commands.WebDavCommand;
import org.exoplatform.services.webdav.resource.DavResource;
import org.exoplatform.services.webdav.resource.DeltaVResource;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: CheckInCommand.java 12304 2007-01-25 10:23:57Z gavrikvetal $
 */

public class CheckInCommand extends WebDavCommand {
  
  protected boolean process() throws RepositoryException {        
    DavResource resource = getResourceFactory().getSrcResource(false);
    
    if (!(resource instanceof DeltaVResource)) {
      davResponse().answerForbidden();
      return false;
    }
    
    Node node = ((DeltaVResource)resource).getNode();
    
    node.checkin();    
    node.getSession().save();
    
    davResponse().answerOk();
    
    return false;
  }
  
}
