/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.webdav.request;

import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.request.documents.AclPrincipalPropSetDoc;
import org.exoplatform.services.webdav.request.documents.AclPrincipalPropsDoc;
import org.exoplatform.services.webdav.request.documents.ExpandPropertyDoc;
import org.exoplatform.services.webdav.request.documents.LockInfoDoc;
import org.exoplatform.services.webdav.request.documents.OrderPatchDoc;
import org.exoplatform.services.webdav.request.documents.PropFindDoc;
import org.exoplatform.services.webdav.request.documents.PropertyBehaviorDoc;
import org.exoplatform.services.webdav.request.documents.PropertyUpdateDoc;
import org.exoplatform.services.webdav.request.documents.SearchRequestDoc;
import org.exoplatform.services.webdav.request.documents.VersionTreeDoc;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: DocumentFactory.java 12004 2007-01-17 12:03:57Z geaz $
 */

public class DocumentFactory {
  
  public static final String [][]AVAILABLE_DOCUMENTS = {
    {DavConst.DavDocument.ACLPRINCIPALPROPS, AclPrincipalPropsDoc.class.getCanonicalName()},
    {DavConst.DavDocument.ACLPRINCIPALPROPSET, AclPrincipalPropSetDoc.class.getCanonicalName()},
    {DavConst.DavDocument.EXPANDPROPERTY, ExpandPropertyDoc.class.getCanonicalName()},
    {DavConst.DavDocument.LOCKINFO, LockInfoDoc.class.getCanonicalName()},
    {DavConst.DavDocument.PROPERTYBEHAVIOR, PropertyBehaviorDoc.class.getCanonicalName()},
    {DavConst.DavDocument.PROPERTYUPDATE, PropertyUpdateDoc.class.getCanonicalName()},
    {DavConst.DavDocument.PROPFIND, PropFindDoc.class.getCanonicalName()},
    {DavConst.DavDocument.VERSIONTREE, VersionTreeDoc.class.getCanonicalName()},
    {DavConst.DavDocument.ORDERPATCH, OrderPatchDoc.class.getCanonicalName()},
    {DavConst.DavDocument.SEARCHREQUEST, SearchRequestDoc.class.getCanonicalName()}
  };    

}
